DAT programName         byte "FourMotors130223a", 0
CON
{{
  Based on code by Hanno.

  Controls four motor with one cog.

  Known Issues:

  Awkward use of "SPEED_MULTIPLIER" constant.
  I'm pretty sure I the value of MIN_PASM_WAIT
  may be reduced.
  I don't like the way "MIN_PASM_WAIT" gets
  added to all values to make sure they aren't
  too small. I'd like to see a check perform and
  only add to wait values when needed to prevent
  values that are too low.
  
  
}}
{
  121215a Begin converting Hano's two motor driver into a four
  motor driver.
  15a Mostly just change formatting.
  15b Remove encoder code.
  15e Change masks to arrays.
  15l Seems to work.
  15m Remove debug code.
  130125a Comment out debug code (again).
  05a Add additional comments
  08a Add check for less than zero speed.
  09a Add debug statements and add demo method.
  Rename "fourMotorsOneCogPst130209a".
  09b Comment out debug code (again).
  14a Modify to use as grandchild object.
  23a Change to use pointer to output speeds.
  Change name to "FourMotors130223a"
  
  Todo:
  Check for identical power settings and turn identical
  settings on and off at the same time.

  
}
{*******************************************************
* (C) 2010 HannoWare.com                               *
* Drive 2 motors with h-bridge and read encoder        *
* AppletImage=motor.gif                                *
********************************************************}

CON
 
  MAXSPEED = 1_600_000 '40_000 high pitched squeal '4_000 ''8_000 '16_000 '
  PARENT_MAXSPEED = 1000
  SPEED_MULTIPLIER = MAXSPEED / PARENT_MAXSPEED
  MIN_PASM_WAIT = 40 '5
  
CON 'Constants used in "Set" method.

  'MAX_PULSE = 2000  
  'MIN_PULSE = 1000
  STOP_PULSE = 1500

CON

  MOTORS_IN_USE = 4
  HIGHEST_MOTOR_ID = MOTORS_IN_USE - 1
    
VAR

  long cog
  long motorControlArray[10]  'structure populated by spin code to set motor direction
  long forwardMask[4]
  long backwardMask[4]
  long enableMask[4]
  long speed[4]
  long outputPtr
  
PUB Start(enablePtr, positivePinPtr, negativePinPtr, outputPtr_)
'' Starts 1 motor cog.

  outputPtr := outputPtr_
  if long[positivePinPtr] <> -1 and long[negativePinPtr] <> -1 and long[enablePtr] <> -1
    forwardMask[0] := |< long[positivePinPtr]
    backwardMask[0] := |< long[negativePinPtr]
    enableMask[0] := |< long[enablePtr]
  else
    forwardMask[0] := 0
    backwardMask[0] := 0
    enableMask[0] := 0
  if long[positivePinPtr][1] <> -1 and long[negativePinPtr][1] <> -1 and long[enablePtr][1] <> -1
    forwardMask[1] := |< long[positivePinPtr][1]
    backwardMask[1] := |< long[negativePinPtr][1]
    enableMask[1] := |< long[enablePtr][1]
  else
    forwardMask[1] := 0
    backwardMask[1] := 0
    enableMask[1] := 0
  if long[positivePinPtr][2] <> -1 and long[negativePinPtr][2] <> -1 and long[enablePtr][2] <> -1
    forwardMask[2] := |< long[positivePinPtr][2]
    backwardMask[2] := |< long[negativePinPtr][2]
    enableMask[2] := |< long[enablePtr][2]
  else
    forwardMask[2] := 0
    backwardMask[2] := 0
    enableMask[2] := 0
  if long[positivePinPtr][3] <> -1 and long[negativePinPtr][3] <> -1 and long[enablePtr][3] <> -1
    forwardMask[3] := |< long[positivePinPtr][3]
    backwardMask[3] := |< long[negativePinPtr][3]
    enableMask[3] := |< long[enablePtr][3]
  else
    forwardMask[3] := 0
    backwardMask[3] := 0
    enableMask[3] := 0
    
  Stop

  motorControlArray[1] := MIN_PASM_WAIT
  motorControlArray[3] := MIN_PASM_WAIT
  motorControlArray[5] := MIN_PASM_WAIT
  motorControlArray[7] := MIN_PASM_WAIT
  motorControlArray[9] := MIN_PASM_WAIT
  allPinsMask := forwardMask[0] | forwardMask[1] | forwardMask[2] | forwardMask[3] | {
  } backwardMask[0] | backwardMask[1] | backwardMask[2] | backwardMask[3] | {
  } enableMask[0] | enableMask[1] | enableMask[2] | enableMask[3]

  cognew(@doPWM, @motorControlArray)

PUB Stop
'' Stop driver and release cog
  
  if cog
    cogstop(cog~ - 1)
 
PUB Update| activeMask, speedIndex[4], startIndex, arrayIndex
'' Updates motor control with desired speeds.
'' Speeds should be between -1000 and 1000.
 
  ' combined PWM pin mask
  activeMask := 0
  {if long[outputPtr] > 0
    activeMask += forwardMask[0]                        ' if #0 positive speed add positive
                                                        ' direction pin to mask
  elseif long[outputPtr] < 0
    activeMask += backwardMask[0]                       ' if #0 negative speed add negative
                                                        ' direction pin to mask
  if long[outputPtr][1] > 0
    activeMask += forwardMask[1]                      
  elseif long[outputPtr][1] < 0
    activeMask += backwardMask[1] 
  if long[outputPtr][2] > 0
    activeMask += forwardMask[2]                      
  elseif long[outputPtr][2] < 0
    activeMask += backwardMask[2]
  if long[outputPtr][3] > 0
    activeMask += forwardMask[3]                      
  elseif long[outputPtr][3] < 0
    activeMask += backwardMask[3]
  }
  
  repeat result from 0 to 3
    if long[outputPtr][result] > 0
      activeMask += forwardMask[result]                      
    elseif long[outputPtr][result] < 0
      activeMask += backwardMask[result]
    speed[result] := (||long[outputPtr][result] * SPEED_MULTIPLIER) <# MAXSPEED
    if speed[result]
      activeMask |= enableMask[result]
  {                           
  speed[0] := (||speed0 * SPEED_MULTIPLIER) <# MAXSPEED
  speed[1] := (||speed1 * SPEED_MULTIPLIER) <# MAXSPEED
  speed[2] := (||speed2 * SPEED_MULTIPLIER) <# MAXSPEED
  speed[3] := (||speed3 * SPEED_MULTIPLIER) <# MAXSPEED
  repeat result from 0 to 3
    if speed[result]
      activeMask |= enableMask[result]
  }
  '' Sort speeds highest to lowest.
  ' There must be a beter way to do this (sorting).
  
  speedIndex[0] := 0
  repeat result from 1 to 3
    if speed[result] > speed[speedIndex[0]]
      speedIndex[0] := result
  repeat result from 1 to 3
    if result <> speedIndex[0]
      startIndex := result
      quit 
  speedIndex[1] := startIndex
  repeat result from startIndex to 3
    if result <> speedIndex[0]
      if speed[result] > speed[speedIndex[1]]
        speedIndex[1] := result
       
  repeat result from 0 to 3
    if result <> speedIndex[0] and result <> speedIndex[1]
      startIndex := result
      quit 
  speedIndex[2] := startIndex
  repeat result from startIndex to 3
    if result <> speedIndex[0] and result <> speedIndex[1]
      if speed[result] > speed[speedIndex[2]]
        speedIndex[2] := result
 
  repeat result from 0 to 3
    if result <> speedIndex[0] and result <> speedIndex[1] and result <> speedIndex[2]
      startIndex := result
      quit 

  speedIndex[3] := startIndex

  motorControlArray[0] := activeMask ' set mask to where the PASM portion
                                     ' can read it
  motorControlArray[1] := speed[speedIndex[3]] + MIN_PASM_WAIT ' time slowest motor is on
  arrayIndex := 2
  repeat result from 3 to 1
    activeMask &= !enableMask[speedIndex[result]]
    motorControlArray[arrayIndex++] := activeMask
    motorControlArray[arrayIndex++] := ||(speed[speedIndex[result- 1]] - speed[speedIndex[result]]) + MIN_PASM_WAIT ' time slowest motor is on
  
  activeMask &= !enableMask[speedIndex[0]]
  motorControlArray[8] := activeMask
  motorControlArray[9] := (MAXSPEED - speed[speedIndex[0]]) + MIN_PASM_WAIT ' time all motors off
   
  result := @activeMask
  
PUB UpdateSingle(motorIndex, localSpeed)
' ** I can probably get rid of this method.

  long[outputPtr][motorIndex] := localSpeed
  'speed[motorIndex] := localSpeed * SPEED_MULTIPLIER
  Update'(speed[0] / SPEED_MULTIPLIER, speed[1] / SPEED_MULTIPLIER, speed[2] / SPEED_MULTIPLIER, speed[3] / SPEED_MULTIPLIER)

PUB Set(pin, width) : motorIndex 
'' Method to provide similar type of input as a continuous rotation servo.
'' "pin" should be the same pin as used to control the enable
'' pin of the H-bridge.
''
'' This method returns the motor ID assigned to "pin" or -1 if "pin" is not
'' not assigned to any motor.
'' This method is not needed for proper operation of object
'' and may be deleted.

  pin := |< pin
  repeat motorIndex from 0 to 3
    if pin & enableMask[motorIndex]
      'width := ((width - STOP_PULSE) * PARENT_MAXSPEED) / (MAX_PULSE - STOP_PULSE)
      width := (width - STOP_PULSE) * 2
      UpdateSingle(motorIndex, width)
      return motorIndex
  motorIndex := -1
   
PUB GetFileName
'' This method returns the name of this object.
'' This method is not needed for proper operation of object
'' and may be deleted.

  result := @programName

PUB GetSpeedLocation
'' This method returns the location of "speed" to aid
'' in debugging the program.
''
'' The value stored in "speed" will be different than the
'' value set by the parent object by the factor "SPEED_MULTIPLIER".
''
'' This method is not needed for proper operation of object
'' and may be deleted.

  result := @speed

PUB GetArrayLocation
'' This method returns the location of "motorControlArray" to aid
'' in debugging the program.
'' This method is not needed for proper operation of object
'' and may be deleted.

  result := @motorControlArray

DAT

' outputs pwm to motors
' uses pwm structure to get bit values and duty cycles
                        org
doPWM                   or      dira, allPinsMask
loop                    mov     tempAddress,par
                        mov     loopCountdown,#5
duty                    mov     previousMask, currentMask
                        rdlong  currentMask,tempAddress 'read mask
                        add     tempAddress,#4
                        rdlong  waitTime, tempAddress 'get wait
                        add     tempAddress, #4
                        andn    outa, previousMask
                        or      outa, currentMask
                        add     waitTime, cnt
                        waitcnt waitTime, #0
                        djnz    loopCountdown, #duty
                        jmp     #loop
                        
allPinsMask             long 1
currentMask             long 0
previousMask            res 1
loopCountdown           res 1
tempAddress             res 1
waitTime                res 1