DAT programName         byte "HeaderRover5_130226a", 0
robotName               byte "Rover 5", 0
  
CON
{{
  ******* Public Notes *******
  
}}
{
  ******* Private Notes *******

  HeaderVexTreads130130a modified DemoFourMotorsAndEncoders130130a
  130130a Move individual robot constants to a header file
  to make it easy to use the same code with multiple robots.
  24a Add DAT section to hold RC pin info.
  
}     
  WHEEL_RED_0 = 18 '17     ' The "RED" constants don't have to be assigned to
  WHEEL_BLACK_0 = 17 '18   ' red wires. It may be useful to switch the pin
  WHEEL_RED_1 = 20         ' assignments if the wheel direction doesn't match
  WHEEL_BLACK_1 = 21       ' the encoder directions.
  WHEEL_RED_2 = 23         ' Set to "-1" if a motor isn't being used.
  WHEEL_BLACK_2 = 24       ' If any of the three motor control pins is
  WHEEL_RED_3 = 27 '26     ' is set to -1, the motor will not receive a PWM
  WHEEL_BLACK_3 = 26 '27   ' signal.
  
  FIRST_ENCODER_0 = 0     ' The next I/O pin higher will also be used.
  FIRST_ENCODER_1 = 2     ' Example: the encoder for motor #1 will use pins 2 and 3.
  FIRST_ENCODER_2 = 4     ' Set to "-1" if a motor isn't being used.
  FIRST_ENCODER_3 = 6
  WHEEL_ENABLE_0 = 16 
  WHEEL_ENABLE_1 = 19  
  WHEEL_ENABLE_2 = 22 
  WHEEL_ENABLE_3 = 25
  RADIO_PIN = 10        ' The program expects six sequencial pins connected to a
                        ' rc receiver. If fewer than six pins are used the
                        ' "BotControl" object will need to be modified (not hard).
                        ' If anyone needs fewer than six pins let me know and I'll
                        ' make the needed changes.
                        ' The "RADIO_PIN" is used the set the values of the 
                        ' "controllerPin" array in the DAT section.
                        
  FORWARD0 = -1         ' If forward robot movement produces negative speed,
  FORWARD1 = -1         ' then the FORWARDx should be set to "-1".
  FORWARD2 = 1          ' Otherwise these should be set to "1".
  FORWARD3 = 1
  FULL_SPEED = 69       ' Measured with PROPORTIONAL_CONSTANT set to zero and
                        ' target speeds set to max allowed (usually 1000).
  PSEUDOREAL_MULTIPLIER = 100 ' If the multiplier is too large values used in calculations
                              ' could exceed 32-bits.
  PSEUDO_FULL_SPEED = FULL_SPEED * PSEUDOREAL_MULTIPLIER
  DEFAULT_ACCELERATION = 30 '40 '20 '12 '8
  PSEUDO_ACCELERATION = DEFAULT_ACCELERATION * PSEUDOREAL_MULTIPLIER
  REFRESH_RATE = 50
  PID_INCREASE = 10  ' to give added precision to proportional constant
  PID_MULTIPLIER = PSEUDOREAL_MULTIPLIER * PID_INCREASE
  PSEUDO_DT = 75   ' not presently used
  PROPORTIONAL_CONSTANT = 10 
  INTEGRAL_CONSTANT = 0 '1 ' not presently used
  DERIVATIVE_CONSTANT = 0  ' not presently used
  STEPS_PER_FIGURE_8 = 1045 ' Used in figure 8, divide by refresh rate to
                            ' compute seconds of driving.
  INPUT_SIGNIFICANT = 20    ' used to detect when landing gear switch as been thrown
  
  ' wheelMode enumeration
  #0, INDEPENDENT_WHEELS, TREADED_WHEELS, MECANUM_WHEELS 

  'WHEEL_MODE = INDEPENDENT_WHEELS '' Use this when first setting up robot
  WHEEL_MODE = TREADED_WHEELS     '' The target speeds of each side will be matched.
  'WHEEL_MODE = MECANUM_WHEELS    
  
  ' inputType enumeration
  #0, PC_ONLY_INPUT, WII_NUNCHUCK_INPUT, RC_INPUT, WII_AND_RC_INPUT, AUTO_DETECT_INPUT

  INPUT_TYPE = PC_ONLY_INPUT       '' Use this when first setting up robot
  'INPUT_TYPE = WII_NUNCHUCK_INPUT   
  'INPUT_TYPE = RC_INPUT
  'INPUT_TYPE = WII_AND_RC_INPUT    '' Not yet supported. If used it will behave the same
                                    '' as AUTO_DETECT_INPUT.                                                                                                                                            
  'INPUT_TYPE = AUTO_DETECT_INPUT   '' Priority given to Nunchuck
  
  DEFAULT_SPEED = 450 '600    ' Used in figure 8 not presently calibrated
                              
  DEFAULT_TURN_RATE = DEFAULT_SPEED / 2 '4  ' Used in figure 8, the larger the turn rate 
                                            ' the larger the loops of the figure 8 will
                                            ' be.
                                            
PUB GetFileName

  result := @programName

PUB GetRobotName

  result := @robotName

PUB GetControllerPins

  result := @controllerPin
  
DAT

controllerPin byte RADIO_PIN, RADIO_PIN + 1, RADIO_PIN + 2, RADIO_PIN + 3
              byte RADIO_PIN + 4, RADIO_PIN + 5
              
DAT '' License
{{
*********************************************************************************************
*                             TERMS OF USE: MIT License                                     *                                                                   
*********************************************************************************************
* Permission is hereby granted, free of charge, to any person obtaining a copy of this      *
* software and associated documentation files (the "Software"), to deal in the Software     *
* without restriction, including without limitation the rights to use, copy, modify,        *
* merge, publish, distribute, sublicense, and/or sell copies of the Software, and to        *
* permit persons to whom the Software is furnished to do so, subject to the following       *
* conditions:                                                                               *
*                                                                                           *                                    
* The above copyright notice and this permission notice shall be included in all copies or  *
* substantial portions of the Software.                                                     *
*                                                                                           *                                   
* The software is provided "as is", without warranty of any kind, express or implied,       *
* including but not limited to the warranties of merchantability, fitness for a particular  *
* and noninfringment. In no event shall the authors or copyright holders be liable for any  *
* claim, damages or other liability, whether in an action of contract, tort or otherwise,   *
* arising from, of or in connection with the software of the use of other dealings in the   *
* software.                                                                                 *
*********************************************************************************************
}}            